#!/usr/bin/perl

use strict;
use warnings;
use DBI;
use Digest::MD5 qw(md5 md5_hex);

use Term::ReadKey;

sub getpass {

  ReadMode 'noecho';
  my $pass = <STDIN>;
  chomp $pass;
  ReadMode 'normal';
  return $pass;

}

sub setnewpass {

  my $username = shift(@_);
  my $pass1 = "a";
  my $pass2 = "b";

  while ( $pass1 ne $pass2 ) {
     
    printf "Enter new password for %s: ", $username;
    $pass1 = getpass;
    print "\n";
    print "Re-enter password: ";	
    $pass2 = getpass;

  }
  print "\n";
  return $pass1;

}

sub setPassForUser {

my $status = 0;
my $dbh = shift(@_);
my $username = shift(@_);

my $pass = setnewpass($username);

my $query = "UPDATE users SET password = ? where username = ?";

my $sth = $dbh->prepare($query)
  or die "Couldn't prepare statement " . $query;

$sth->bind_param(1, md5_hex($pass) );
$sth->bind_param(2, $username );

$sth->execute() 
  or die "Couldn't execute statement: " . $sth->errstr;
if ($sth->rows == 0) {
  print "No user with username $username.\n";

} else {
  $status = 1;
}

$sth->finish();

return $status;

}

# Start of main routine

die "Usage: xvoms_changepass USERNAMES" if ($#ARGV eq -1);

my $db = "xvoms";
my $userid = "root";
my $connection = "dbi:mysql:$db;";   

print "Enter password for MySQL root user:";

my $passwd = getpass;
print "\n";                             

my $dbh = DBI->connect($connection,$userid,$passwd)
  or die; # DBI->errstr(); # errstr() not worth printing
 
foreach my $argnum (0 .. $#ARGV) {

  my $status = setPassForUser($dbh, $ARGV[$argnum]);

  if ($status eq 1) {
    printf "Changed password for %s.\n", $ARGV[$argnum];
  } else {
    printf "Failed to change password for %s.\n", $ARGV[$argnum];
  } 

}
 
$dbh->disconnect();

