<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns="http://www.w3.org/1999/xhtml">
	<xsl:output indent="yes" omit-xml-declaration="yes"/>
	<xsl:strip-space elements="*"/>

	<xsl:template match="/">
		<html>
			<head>
				<title>JUnit Test Suit</title>
				<style type="text/css"> 
					body {
					width: 1024px;
					font-family: Verdana, arial,serif;
					}
					table {
					width:100%;
					}
					h1 {
					font-size: 16px;
					font-weight: bold;
					} 
					h2 {
					font: 14px;
					font-weight: bold;
					color: blue;
					} 
					h3 {
					font-size: 12px;
					color: blue;
					} 
					body {
					font-sise: 10px;
					} 
					th {
					font-size: 12px;
					font-weight: bold;
					background-color: lightblue; 
					padding=0.5em
					} 
					td {
					font-size: 11px;	
					background-color: lightgrey; 
					padding=0.5em
					}
					td.alert {
					color: #fff;
					font-weight: bold;
					background-color: #f00; 
					}
					.author {
					font-size: 11px;
					color: #aaa;
					}
				</style>
			</head>
			<body>
				<h1>X-VOMS Junit Test Results</h1>
				<div class="author">Erica Yang @ STFC at Feb. 2010</div>
				<hr/>
				<h2>Summary</h2>
				<table>
					<tr>
						<th>Test Suite</th>
						<th>No. of Tests</th>
						<th>Errors</th>
						<th>Failures</th>
						<th>Time (seconds)</th>
						<th>Timestamp</th>
						<th>Success Rate</th>
					</tr>
					<xsl:apply-templates select="//testsuite"/>
				</table>
				<hr/>
				<table>
					<tr>
						<th>Test Name</th>
						<th>Class Name</th>
						<th>Time (seconds)</th>
					</tr>
					<xsl:apply-templates select="//testcase">
						<xsl:sort select="@name"/>
					</xsl:apply-templates>
				</table>
			</body>
		</html>
	</xsl:template>

	<xsl:template match="testsuite">
		<tr>
			<td>
				<xsl:value-of select="@name"/>
			</td>
			<td>
				<xsl:value-of select="@tests"/>
			</td>
			<xsl:choose>
				<xsl:when test=" number(@errors) > 0">
					<td class="alert">
						<xsl:value-of select="@errors"/>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td>
						<xsl:value-of select="@errors"/>						
					</td>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test=" number(@errors) > 0">
					<td class="alert">
						<xsl:value-of select="@failures"/>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td>
						<xsl:value-of select="@failures"/>						
					</td>
				</xsl:otherwise>
			</xsl:choose>
			<td>
				<xsl:value-of select="@time"/>
			</td>
			<td>
				<xsl:value-of select="@timestamp"/>
			</td>
			<td id="successrate">
				<xsl:value-of select="(1 - (number(@errors) div number(@tests))) * 100"/>% 
			</td>
		</tr>
	</xsl:template>

	<xsl:template match="testcase">
		<tr>
			<td>
				<xsl:value-of select="@name"/>
			</td>
			<td>
				<xsl:value-of select="@classname"/>
			</td>
			<td>
				<xsl:value-of select="@time"/>
			</td>
		</tr>
	</xsl:template>

	<!--     
		<xsl:template match="card[@type='simple']">
		<html xmlns="http://www.w3.org/1999/xhtml">
		<table>
		<xsl:for-each select="./Properties/Property">
		<xsl:sort select="@name" />
		<tr>
		<td>
		<xsl:value-of select="@name" />
		</td>
		<td>
		<xsl:value-of select="@value" />
		</td>
		</tr>
		</xsl:for-each>
		</table>
		</html>
		</xsl:template>
	-->
</xsl:stylesheet>
